<?php

namespace ebay\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RestockingFeeValueDetailsType StructType
 * Meta informations extracted from the WSDL
 * - documentation: Type defining the <b>RestockingFeeValue</b> container, which contains the allowed values (and a text description of each value) that may be specified in the <b>RestockingFeeValueOption</b> field of an Add/Revise/Relist API call.
 * @subpackage Structs
 * @date 2017-04-07 16
 */
class RestockingFeeValueDetailsType extends AbstractStructBase
{
    /**
     * The RestockingFeeValueOption
     * Meta informations extracted from the WSDL
     * - documentation: A restocking fee value option that a seller can specify in the <b>RestockingFeeValueOption</b> field of Add/Revise/Relist calls. In order to charge a buyer a restocking fee when an item is returned, a US seller must input a
     * restocking fee value as part of the return policy.
     * - minOccurs: 0
     * @var string
     */
    public $RestockingFeeValueOption;
    /**
     * The Description
     * Meta informations extracted from the WSDL
     * - documentation: Display string that applications can use to present the <b>RestockingFeeValueOption</b> values in a more user-friendly format when used in GUI features such as option buttons or drop-down lists.
     * - minOccurs: 0
     * @var string
     */
    public $Description;
    /**
     * The any
     * @var \DOMDocument
     */
    public $any;
    /**
     * Constructor method for RestockingFeeValueDetailsType
     * @uses RestockingFeeValueDetailsType::setRestockingFeeValueOption()
     * @uses RestockingFeeValueDetailsType::setDescription()
     * @uses RestockingFeeValueDetailsType::setAny()
     * @param string $restockingFeeValueOption
     * @param string $description
     * @param \DOMDocument $any
     */
    public function __construct($restockingFeeValueOption = null, $description = null, \DOMDocument $any = null)
    {
        $this
            ->setRestockingFeeValueOption($restockingFeeValueOption)
            ->setDescription($description)
            ->setAny($any);
    }
    /**
     * Get RestockingFeeValueOption value
     * @return string|null
     */
    public function getRestockingFeeValueOption()
    {
        return $this->RestockingFeeValueOption;
    }
    /**
     * Set RestockingFeeValueOption value
     * @param string $restockingFeeValueOption
     * @return \ebay\StructType\RestockingFeeValueDetailsType
     */
    public function setRestockingFeeValueOption($restockingFeeValueOption = null)
    {
        // validation for constraint: string
        if (!is_null($restockingFeeValueOption) && !is_string($restockingFeeValueOption)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($restockingFeeValueOption)), __LINE__);
        }
        $this->RestockingFeeValueOption = $restockingFeeValueOption;
        return $this;
    }
    /**
     * Get Description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param string $description
     * @return \ebay\StructType\RestockingFeeValueDetailsType
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($description)), __LINE__);
        }
        $this->Description = $description;
        return $this;
    }
    /**
     * Get any value
     * @uses \DOMDocument::loadXML()
     * @uses \DOMDocument::hasChildNodes()
     * @uses \DOMDocument::saveXML()
     * @uses \DOMNode::item()
     * @uses \ebay\StructType\RestockingFeeValueDetailsType::setAny()
     * @param bool $asString true: returns XML string, false: returns \DOMDocument
     * @return \DOMDocument|null
     */
    public function getAny($asString = true)
    {
        if (!empty($this->any) && !($this->any instanceof \DOMDocument)) {
            $dom = new \DOMDocument('1.0', 'UTF-8');
            $dom->formatOutput = true;
            if ($dom->loadXML($this->any)) {
                $this->setAny($dom);
            }
            unset($dom);
        }
        return ($asString && ($this->any instanceof \DOMDocument) && $this->any->hasChildNodes()) ? $this->any->saveXML($this->any->childNodes->item(0)) : $this->any;
    }
    /**
     * Set any value
     * @param \DOMDocument $any
     * @return \ebay\StructType\RestockingFeeValueDetailsType
     */
    public function setAny(\DOMDocument $any = null)
    {
        $this->any = $any;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \ebay\StructType\RestockingFeeValueDetailsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
